unit terminal;
//===============================================================
// This small form demonstrate capacity of NRCOMM component.
//
// NoRo|Kolobock (noro@chat.ru)
interface

uses
  Windows, Messages, Classes,Controls, Forms,
  ToolWin, ComCtrls, StdCtrls, nrcomm, ExtCtrls;

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    StatusL: TLabel;
    ToolButton6: TToolButton;
    M: TMemo;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Bar: TStatusBar;
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    ComBox: TComboBox;
    ListBox1: TListBox;
    Label1: TLabel;
    Com: TnrComm;
    ToolButton1: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure MKeyPress(Sender: TObject; var Key: Char);
    procedure GoBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ComListEvent(I: Integer; List: TEventList);
    procedure FormShow(Sender: TObject);
    procedure ComBoxChange(Sender: TObject);
    procedure ComRecived(Buffer: Pointer; Recived: Cardinal);
    procedure ToolButton1Click(Sender: TObject);
  private
  public
//    Com,Com2:TnrComm;   
  end;

var
  Form1: TForm1;

implementation
uses sysutils,dialogs;
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Com.EventList.AddNewEvent(PChar('OK'),2);
  Com.EventList.AddNewEvent(PChar('RING'),4);
  Com.EventList.AddNewEvent(PChar('ERROR'),5);
  Com.Active:=True;
//  Com2.Active:=True;
//  Com2.EventList.AddNewEvent(PChar('OK'),2);
//  Com2.EventList.AddNewEvent(PChar('RING'),4);
//  Com2.EventList.AddNewEvent(PChar('ERROR'),5);
end;

procedure TForm1.MKeyPress(Sender: TObject; var Key: Char);
begin
  if not Com.TerminalLocked then Com.SendChar(Key);
end;

procedure TForm1.GoBtnClick(Sender: TObject);
begin
//  Com.CommThread.TerminalOnLine:=not Com.CommThread.TerminalOnLine;
//  Com.SendString('ATDL');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  Com.Active:=False;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  Com.ConfigDialog;
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
  Com.ResetModem;
  Com.SendString('ATE1');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Com.EventList.AddNewEvent(PChar(Edit1.Text),Length(Edit1.Text));
  ListBox1.Items.Clear;
  FormShow(Self);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Com.EventList.Clear;
  ListBox1.Items.Clear;
  FormShow(Self);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Com.EventList.Delete(ListBox1.ItemIndex);
  ListBox1.Items.Clear;
  FormShow(Self);
end;

procedure TForm1.ComListEvent(I: Integer; List: TEventList);
begin
  Bar.Panels[2].Text:='COMPORT Status:'+List.EventString[i];
end;

procedure TForm1.FormShow(Sender: TObject);
var i:integer;
begin
  for i:=0 to Com.EventList.Count-1
    do ListBox1.Items.Add(Com.EventList.EventString[i]);
end;

procedure TForm1.ComBoxChange(Sender: TObject);
begin
  Com.Active:=False;
  Com.ComPort:=TComPort(ComBox.ItemIndex);
  Com.Active:=True;
end;

procedure TForm1.ComRecived(Buffer: Pointer; Recived: Cardinal);
begin
  Bar.Panels[0].Text:='Total Recived='+IntToStr(Com.TotalRecived);
  Bar.Panels[1].Text:='Total Sended='+IntToStr(Com.TotalSended);
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  Com.EoLnOnLine:=not Com.EoLnOnLine;
end;

end.
